--This file is used with Rabbit's premission, the author of CraftyGnome.
--Basicly CraftyGnome.lua as a templet with some code stripped out, and what code I wanted to run added, with no chat search
--I did this because: CG scanned the trade window's items, and saved the strings to a table. Also, it had the menu when click on a trade item. Lastly, I did not fell like writing myself, when this templet was existing =P
--Most of the code for the trade and craft skill scanning and storing was copied from CraftyGnome by Rabbit.


-----------------------------------------------------------------------
-- Locale
--

local fnd = _G.string.find
local lower = _G.string.lower
local sub = _G.string.sub
local rep = _G.strreplace
local tostr = _G.tostring
local tonum = _G.tonumber

local testtable = {}
local l = GetLocale()
local _PLAYER_ENTERING_WORLD
local getCurrentLink
lastlinked = ""
local TOO_MANY = "Too many results, %d not shown. Whisper me !next to get more."
local PREFIX = "cg: "
local NOTE = "%s: %s."
local CG_USAGE = "Whisper me '!%s <anything>' to search."
local NO_DATA = "No results found for %q."
local NO_SKILL = "I don't know this skill. Accepted commands are %s."
local ACCEPTED = "Accepted commands are %s."
local HELP = {
	"Trade Secretary: Ad Repeater accepts various !<skill> commands in whispers or guild chat based on what trade skills the player has available.",
	"Usage: !command <token1> <token2> ...",
	"Each token is matched against all the text that is present in all the recipe tooltips available to this player.",
	"Only tooltips that contain all the given tokens are returned as results to you.",
}
local MENU_HELP = "|cff00ff00Trade Secretary: Ad Repeater|r: |cffeda55fRight-Click|r a tradeskill or craft item line in order to get a hyperlink."
--math.floor(string.len(AdModAds[mainAd][subAd]) - 255)
local POPUP_TEXT = "|cff00ff00Trade Secretary: Ad Repeater|r\n\n%s is %s characters.\n Coppy the item link bellow."
local IGNORED = " |cff990000(ignored)|r"

-- Menu locale strings
local MENU = {
	ADNOTE = "Cancel",
	ADNOTE_DESC = "Click to get the craftable itemLink",
	--IGNORE = "Ignore",
	--IGNORE_DESC = "Toggle whether or not to ignore this item. Bind on pickup items are always ignored.",
}

-----------------------------------------------------------------------
-- Tooltip scanner, mostly stolen from Gratuity.
--

local scanItem
do
	local scanner = CreateFrame("GameTooltip")
	scanner:SetOwner(WorldFrame, "ANCHOR_NONE")
	local lcache, rcache = {}, {}
	for i = 1, 30 do
		lcache[i], rcache[i] = scanner:CreateFontString(), scanner:CreateFontString()
		lcache[i]:SetFontObject(GameFontNormal); rcache[i]:SetFontObject(GameFontNormal)
		scanner:AddFontStrings(lcache[i], rcache[i])
	end
	local function erase()
		for i = 1, scanner:NumLines() do rcache[i]:SetText() end
		scanner:ClearLines()
	end
	local scannerCache = {}
	function scanItem(itemLink)
		local getName = ""
		--DEFAULT_CHAT_FRAME:AddMessage("--NEW--")
		erase()
		scanner:SetHyperlink(itemLink)
		for k in pairs(scannerCache) do scannerCache[k] = nil end
		for i = 1, scanner:NumLines() do
			local left, right = lcache[i]:GetText(), rcache[i]:GetText()
			if left then table.insert(scannerCache, left) end
			if right then table.insert(scannerCache, right) end
			--DEFAULT_CHAT_FRAME:AddMessage("--")
			--DEFAULT_CHAT_FRAME:AddMessage("right: "..(right or "").. " in: ".. i)
			--DEFAULT_CHAT_FRAME:AddMessage("left: "..(left or "").. " in: ".. i)
			--DEFAULT_CHAT_FRAME:AddMessage("--")
			
		end
		return table.concat(scannerCache), lcache[1]:GetText()
	end
end

-----------------------------------------------------------------------
-- CraftyGnome
--
--[[
local fa = GetLocale() == "frFR" and "Premiers soins" or GetSpellInfo(746)

local bangMappings = {
	alchemy = (GetSpellInfo(2259)),
	blacksmith = (GetSpellInfo(2018)),
	cooking = (GetSpellInfo(2550)),
	leather = (GetSpellInfo(2108)),
	enchanting = (GetSpellInfo(7411)),
	engineering = (GetSpellInfo(4036)),
	firstaid = fa,
	jewel = (GetSpellInfo(25229)),
	tailor = (GetSpellInfo(3908)),
}
bangMappings.alc = bangMappings.alchemy
bangMappings.bs = bangMappings.blacksmith
bangMappings.cook = bangMappings.cooking
bangMappings.lw = bangMappings.leather
bangMappings.enchant = bangMappings.enchanting
bangMappings.eng = bangMappings.engineering
bangMappings.aid = bangMappings.firstaid
bangMappings.jc = bangMappings.jewel
bangMappings.gem = bangMappings.jewel
bangMappings.tailoring = bangMappings.tailor
bangMappings.craft = true
bangMappings.cg = true
bangMappings.next = true
bangMappings.help = true

local MAX_RESULTS = 5
]]
AdModCraftHyperLinks = {}
local ignoreDB = {}
local notesDB = {}

--local bop = ITEM_BIND_ON_PICKUP
local cache = {}
local acceptedCommands = {}
local addon = CreateFrame("Frame")
local _G = _G

--------------------------------------------------------------------------------
-- Right-click menu for craft/tradeskill UI
--

local function forceUpdate()
	if TradeSkillFrame and TradeSkillFrame:IsVisible() then TradeSkillFrame_Update() end
	if CraftFrame and CraftFrame:IsVisible() then CraftFrame_Update() end
end

local currentItem = nil
local currentRecipe = nil

local function isIgnored(item)
	return ignoreDB[item or currentItem]
end
local function toggleIgnored()
	ignoreDB[currentItem] = not ignoreDB[currentItem]
	forceUpdate()
end

local function getNote(item)
	return notesDB[item or currentItem]
end
local function setNote(item, note)
	if type(note) ~= "string" or note:trim():len() < 2 then note = nil end
	notesDB[item or currentItem] = note
	forceUpdate()
end--currentRecipe
local function showNotePopup()
	StaticPopupDialogs["AdModNote"].text = POPUP_TEXT:format(currentItem,  (math.floor(string.len(currentItem)) or 0))
	StaticPopup_Show("AdModNote")
	--getglobal(this:GetName().."EditBox"):SetText("Some data")
end

local menu = {{
	text = MENU.ADNOTE,
	tooltipTitle = MENU.ADNOTE,
	tooltipText = MENU.ADNOTE_DESC,
	func = showNotePopup,
},{
	--text = MENU.IGNORE,
	--tooltipTitle = MENU.IGNORE,
	--tooltipText = MENU.IGNORE_DESC,
	--func = toggleIgnored,
	--checked = isIgnored,
},}

local popupFrame = CreateFrame("Frame", "AdModMenu", addon, "UIDropDownMenuTemplate")
--[[local function openMenu(frame, recipe)
	StaticPopup_Hide("AdModNote")
	currentRecipe = gsub(recipe or "", "\124", "\124\124");
	--ChatFrame1:AddMessage("Here's what it really looks like: \"" .. currentRecipe .. "\"");
	currentItem = recipe
	
	--DEFAULT_CHAT_FRAME:AddMessage("|cffffd000|Henchant:8604|h[Cooking: Herb Baked Egg]|h|r")
	--/script DEFAULT_CHAT_FRAME:AddMessage("Shift-click this to place a link into a chat message: \124cffffd000\124Henchant:8604\124h[Cooking: Herb Baked Egg]\124h\124r");
	--	["|cffffd000|Henchant:8604|h[Cooking: Herb Baked Egg]|h|r"] = 7,
	--DEFAULT_CHAT_FRAME:AddMessage("currentItem: "..(currentItem or ""))
	EasyMenu(menu, popupFrame, frame, 20, 4, "MENU")
end]]

local function onTradeSkillDoubleClick()
	StaticPopup_Hide("AdModNote")
	local recipe = GetTradeSkillRecipeLink(this:GetID())
	if recipe then
		currentRecipe = gsub(recipe or "", "\124", "\124\124");
		currentItem = recipe
		showNotePopup()
	end
	--StaticPopupDialogs_Show("AdModNote")
	--EasyMenu(menu, popupFrame, frame, 20, 4, "MENU")	---if recipe then openMenu(this, recipe) end
end
local function onCraftDoubleClick()
	StaticPopup_Hide("AdModNote")
	local recipe = GetCraftRecipeLink(this:GetID())
	if recipe then
		currentRecipe = gsub(recipe or "", "\124", "\124\124");		
		currentItem = recipe
		showNotePopup()
	end
	--StaticPopupDialogs_Show("AdModNote")
	--EasyMenu(menu, popupFrame, frame, 20, 4, "MENU")	--if recipe then openMenu(this, recipe) end
end

local recursive = nil
local function updateSkillLine(line, text, recipe)
	local note = getNote(recipe)
	local ignored = isIgnored(recipe)
	local append = nil
	if note then append = " - " .. note end
	if ignored then append = (append or "") .. IGNORED end
	if append then
		recursive = true
		line:SetText(text .. append)
	end
end
local function onTradeSkillLineSet(this, text)
	if recursive then recursive = nil; return end
	local recipe = GetTradeSkillRecipeLink(this:GetID())
	if recipe then updateSkillLine(this, text, recipe) end
end
local function onCraftLineSet(this, text)
	if recursive then recursive = nil; return end
	local recipe = GetCraftRecipeLink(this:GetID())
	if recipe then updateSkillLine(this, text, recipe) end
end

--n:SetScript("OnClick", function(self, button) --[[ ... do stuff here ... ]] end);
--"LeftButtonUp","RightButtonUp","MiddleButtonUp","Button4Up","Button5Up","LeftButtonDown","RightButtonDown","MiddleButtonDown","Button4Down","Button5Down","AnyUp","AnyDown"
function addon:ADDON_LOADED(name)
	if name == "Blizzard_TradeSkillUI" then
		for i = 1, 8 do
			local button1 = _G["TradeSkillSkill" .. i]
			button1:RegisterForClicks("AnyDown")
			button1:HookScript("OnClick", function(self, button) if button == "RightButton" then  onTradeSkillDoubleClick() end end)
			end
		DEFAULT_CHAT_FRAME:AddMessage(MENU_HELP)
	elseif name == "Blizzard_CraftUI" then
		for i = 1, 8 do--DEFAULT_CHAT_FRAME:AddMessage(
			local button1 = _G["Craft" .. i]
			button1:RegisterForClicks("AnyDown")
			button1:HookScript("OnClick", function(self, button) if button == "RightButton" then onCraftDoubleClick() end end)
		end
		DEFAULT_CHAT_FRAME:AddMessage(MENU_HELP)
	elseif name == "TradeSecretaryAd" then
		_PLAYER_ENTERING_WORLD()
	end
end

--------------------------------------------------------------------------------
-- Craft/tradeskill scanning
--

-- XXX we should just save the spell ID in the database like I did originally,
-- XXX maybe we can use GetSpellLink and GetSpellInfo on the recipe IDs in 2.4
-- XXX in any case, we can just create the links manually from the ID like
-- XXX |cffffd000|Henchant:"..recipeId.."|h[Placeholder Name]|h|r"
-- XXX and then use tooltip:SetHyperlink
-- XXX if we do this we also have to get the name and from the tooltip so we can
-- XXX construct the recipe link properly when someone wants a link

--[[
local function onCraftDoubleClick()
	StaticPopup_Hide("AdModNote")
	local recipe = GetCraftRecipeLink(this:GetID())
	currentRecipe = gsub(recipe or "", "\124", "\124\124");		
	currentItem = recipe
	showNotePopup()
	--StaticPopupDialogs_Show("AdModNote")
	--EasyMenu(menu, popupFrame, frame, 20, 4, "MENU")	--if recipe then openMenu(this, recipe) end
end

]]

--[[function ADMOD_ChatFrame_OnHyperlinkShow(reference, itemString, link, button)
	testtable = reference
	lastlinked = link
	--DEFAULT_CHAT_FRAME:AddMessage("itemString: "..(itemString or ""))
	--DEFAULT_CHAT_FRAME:AddMessage("link: "..(link or ""))
	--DEFAULT_CHAT_FRAME:AddMessage("button: "..(button or ""))
	StaticPopup_Hide("AdModNote")
	--local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount,itemEquipLoc, itemTexture = GetItemInfo(link) 
	--DEFAULT_CHAT_FRAME:AddMessage("itemLink: "..(itemLink or ""))
	--local recipe = GetCraftRecipeLink(this:GetID())
	currentRecipe = gsub(string.format ('%q', link) or "", "\124", "\124\124");	
	_,_,currentRecipe = string.find(currentRecipe or "", "^\"(.*)\"$")
	currentItem = link or ""
	showNotePopup()
end]]

SLASH_TRADESECRETARYAD_GETLINK1 = "/getlink"
SLASH_TRADESECRETARYAD_GETLINK2 = "/gli"
SLASH_TRADESECRETARYAD_GETLINK3 = "/glink"
SlashCmdList["TRADESECRETARYAD_GETLINK"] = function( link )
	if (not link) or ( link == "") then return end
	StaticPopup_Hide("AdModNote")
	--local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount,itemEquipLoc, itemTexture = GetItemInfo(link) 
	--DEFAULT_CHAT_FRAME:AddMessage("itemLink: "..(itemLink or ""))
	--local recipe = GetCraftRecipeLink(this:GetID())
	currentRecipe = gsub(string.format ('%q', link) or "", "\124", "\124\124");	
	_,_,currentRecipe = string.find(currentRecipe or "", "^\"(.*)\"$")
	--currentRecipe = gsub(string.format ('%q', currentRecipe) or "", string.format ('%q',"\"\124\""), "\124");	
	currentItem = link or ""
	showNotePopup()
end

function addon:CRAFT_SHOW()
	local name = GetCraftName()
	if not name then return end
	--DEFAULT_CHAT_FRAME:AddMessage(name)
	if not AdModCraftHyperLinks[name] then AdModCraftHyperLinks[name] = {} end
	for i = 1, GetNumCrafts() do
		local skillName, _, skillType, _, _, _, level = GetCraftInfo(i)
		if skillType ~= "header" and skillName then
			local recipe = GetCraftRecipeLink(i)
			--DEFAULT_CHAT_FRAME:AddMessage(recipe)
			if recipe then--if recipe and not isIgnored(recipe) then
				local tooltipContents, itemName = scanItem(recipe)
				local l = level or 1
				--DEFAULT_CHAT_FRAME:AddMessage("itemName: "..(itemName or ""))
				if not AdModCraftHyperLinks[name][recipe] or AdModCraftHyperLinks[name][recipe] < l then 
					AdModCraftHyperLinks[name][recipe] = l 
				end
			end
		end
	end
end

--[[
local function searchForBop(...)
	for i = 1, select("#", ...) do
		if select(i, ...) == bop then return true end
	end
end
]]

function addon:TRADE_SKILL_SHOW()
	--DEFAULT_CHAT_FRAME:AddMessage("TRADE_SKILL_SHOW()")
	local name = GetTradeSkillLine()
	if not name then return end
	if not AdModCraftHyperLinks[name] then AdModCraftHyperLinks[name] = {} end
	for i = 1, GetNumTradeSkills() do
		local skillName, skillType = GetTradeSkillInfo(i)
		if skillType ~= "header" and skillName then --		if skillType ~= "header" and skillName and not searchForBop(GetTradeSkillItemStats(i)) then
			local link = GetTradeSkillItemLink(i)
			local recipe = GetTradeSkillRecipeLink(i)
			local itemName = GetItemInfo(recipe)
			if link and recipe then --if link and recipe and not isIgnored(recipe) then
				local _, _, _, level = GetItemInfo(link)
				local l = level or 1
				if not AdModCraftHyperLinks[name][recipe] or AdModCraftHyperLinks[name][recipe] < l then
					AdModCraftHyperLinks[name][recipe] = l
				end
			end
		end
	end
end


--------------------------------------------------------------------------------
-- Core addon and event handling
--

function _PLAYER_ENTERING_WORLD()
	if not ADModDB then ADModDB = {} end
	local realm = GetRealmName()
	if not ADModDB[realm] then ADModDB[realm] = {} end
	local faction = UnitFactionGroup("player")
	if not ADModDB[realm][faction] then ADModDB[realm][faction] = {} end
	db = ADModDB[realm][faction]

	if not db.version or db.version < 4 then
		for k in pairs(db) do db[k] = nil end
		db.version = 4
	end

	if not ADModDB.ignoredItems then ADModDB.ignoredItems = {} end
	ignoreDB = ADModDB.ignoredItems

	if not ADModDB.notes then ADModDB.notes = {} end
	notesDB = ADModDB.notes


	StaticPopupDialogs["AdModNote"] = {
		text = nil,
		button1 = MENU.ADNOTE,
		button2 = CANCEL,
		whileDead = 1,
		hideOnEscape = 1,
		timeout = 0,
		OnShow = function()
			-- We have to do this onshow to reset the previous text
			
			_G[this:GetName().."EditBox"]:SetText(currentRecipe or "")
		end,
		OnHide = function()
			_G[this:GetName().."EditBox"]:SetText("")
		end,
		EditBoxOnEnterPressed = function()
			local t = _G[this:GetParent():GetName().."EditBox"]:GetText()
			setNote(currentItem, t)
			this:GetParent():Hide()
		end,
		EditBoxOnEscapePressed = function()
			this:GetParent():Hide()
		end,
		OnAccept = function()
			local t = _G[this:GetParent():GetName().."EditBox"]:GetText()
			setNote(currentItem, t)
		end,
		hasEditBox = 1,
	}

end
--[[
ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", function(_,event,msg)
	local _,_,cmd = fnd(msg,"^!(%S+)")
	if cmd and bangMappings[cmd:lower()] then return true end
    return false, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11 
end)
local chatPrefixTest = "^" .. PREFIX
ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER_INFORM", function(_,event,msg)
	if fnd(msg,chatPrefixTest) then return true end
    return false, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11 
end)
]]
addon:SetScript("OnEvent", function(self, event, ...)
	self[event](self, ...)
end)
addon:RegisterEvent("CRAFT_SHOW")
addon:RegisterEvent("TRADE_SKILL_SHOW")
addon:RegisterEvent("ADDON_LOADED")
--hook ChatFrame_OnHyperlinkShow(reference, link, button)
--hooksecurefunc("ChatFrame_OnHyperlinkShow", ADMOD_ChatFrame_OnHyperlinkShow)
